<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AdditionalCollectionInfo StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AdditionalCollectionInfo
 * @subpackage Structs
 */
class AdditionalCollectionInfo extends AbstractStructBase
{
    /**
     * The BaseCurrencyAmount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\AdditionalCollectionAmount
     */
    public $BaseCurrencyAmount;
    /**
     * The NucCurrencyAmount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\AdditionalCollectionAmount
     */
    public $NucCurrencyAmount;
    /**
     * The SaleCurrencyAmount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\AdditionalCollectionAmount
     */
    public $SaleCurrencyAmount;
    /**
     * Constructor method for AdditionalCollectionInfo
     * @uses AdditionalCollectionInfo::setBaseCurrencyAmount()
     * @uses AdditionalCollectionInfo::setNucCurrencyAmount()
     * @uses AdditionalCollectionInfo::setSaleCurrencyAmount()
     * @param \App|C\StructType\AdditionalCollectionAmount $baseCurrencyAmount
     * @param \App|C\StructType\AdditionalCollectionAmount $nucCurrencyAmount
     * @param \App|C\StructType\AdditionalCollectionAmount $saleCurrencyAmount
     */
    public function __construct(\App|C\StructType\AdditionalCollectionAmount $baseCurrencyAmount = null, \App|C\StructType\AdditionalCollectionAmount $nucCurrencyAmount = null, \App|C\StructType\AdditionalCollectionAmount $saleCurrencyAmount = null)
    {
        $this
            ->setBaseCurrencyAmount($baseCurrencyAmount)
            ->setNucCurrencyAmount($nucCurrencyAmount)
            ->setSaleCurrencyAmount($saleCurrencyAmount);
    }
    /**
     * Get BaseCurrencyAmount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\AdditionalCollectionAmount|null
     */
    public function getBaseCurrencyAmount()
    {
        return isset($this->BaseCurrencyAmount) ? $this->BaseCurrencyAmount : null;
    }
    /**
     * Set BaseCurrencyAmount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\AdditionalCollectionAmount $baseCurrencyAmount
     * @return \App|C\StructType\AdditionalCollectionInfo
     */
    public function setBaseCurrencyAmount(\App|C\StructType\AdditionalCollectionAmount $baseCurrencyAmount = null)
    {
        if (is_null($baseCurrencyAmount) || (is_array($baseCurrencyAmount) && empty($baseCurrencyAmount))) {
            unset($this->BaseCurrencyAmount);
        } else {
            $this->BaseCurrencyAmount = $baseCurrencyAmount;
        }
        return $this;
    }
    /**
     * Get NucCurrencyAmount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\AdditionalCollectionAmount|null
     */
    public function getNucCurrencyAmount()
    {
        return isset($this->NucCurrencyAmount) ? $this->NucCurrencyAmount : null;
    }
    /**
     * Set NucCurrencyAmount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\AdditionalCollectionAmount $nucCurrencyAmount
     * @return \App|C\StructType\AdditionalCollectionInfo
     */
    public function setNucCurrencyAmount(\App|C\StructType\AdditionalCollectionAmount $nucCurrencyAmount = null)
    {
        if (is_null($nucCurrencyAmount) || (is_array($nucCurrencyAmount) && empty($nucCurrencyAmount))) {
            unset($this->NucCurrencyAmount);
        } else {
            $this->NucCurrencyAmount = $nucCurrencyAmount;
        }
        return $this;
    }
    /**
     * Get SaleCurrencyAmount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\AdditionalCollectionAmount|null
     */
    public function getSaleCurrencyAmount()
    {
        return isset($this->SaleCurrencyAmount) ? $this->SaleCurrencyAmount : null;
    }
    /**
     * Set SaleCurrencyAmount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\AdditionalCollectionAmount $saleCurrencyAmount
     * @return \App|C\StructType\AdditionalCollectionInfo
     */
    public function setSaleCurrencyAmount(\App|C\StructType\AdditionalCollectionAmount $saleCurrencyAmount = null)
    {
        if (is_null($saleCurrencyAmount) || (is_array($saleCurrencyAmount) && empty($saleCurrencyAmount))) {
            unset($this->SaleCurrencyAmount);
        } else {
            $this->SaleCurrencyAmount = $saleCurrencyAmount;
        }
        return $this;
    }
}
