<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ETTicketDetails StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ETTicketDetails
 * @subpackage Structs
 */
class ETTicketDetails extends ApiObject
{
    /**
     * The IFTIssuanceInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\IFTIssuanceInfo
     */
    public $IFTIssuanceInfo;
    /**
     * The ORGIssuanceInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\ORGIssuanceInfo
     */
    public $ORGIssuanceInfo;
    /**
     * The DATIssuanceInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\DATIssuanceInfo
     */
    public $DATIssuanceInfo;
    /**
     * The PartnerIssuanceInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\PartnerIssuanceInfo
     */
    public $PartnerIssuanceInfo;
    /**
     * The ETCouponExchangedInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfETCouponExchangedInfo
     */
    public $ETCouponExchangedInfo;
    /**
     * Constructor method for ETTicketDetails
     * @uses ETTicketDetails::setIFTIssuanceInfo()
     * @uses ETTicketDetails::setORGIssuanceInfo()
     * @uses ETTicketDetails::setDATIssuanceInfo()
     * @uses ETTicketDetails::setPartnerIssuanceInfo()
     * @uses ETTicketDetails::setETCouponExchangedInfo()
     * @param \App|C\StructType\IFTIssuanceInfo $iFTIssuanceInfo
     * @param \App|C\StructType\ORGIssuanceInfo $oRGIssuanceInfo
     * @param \App|C\StructType\DATIssuanceInfo $dATIssuanceInfo
     * @param \App|C\StructType\PartnerIssuanceInfo $partnerIssuanceInfo
     * @param \App|C\ArrayType\ArrayOfETCouponExchangedInfo $eTCouponExchangedInfo
     */
    public function __construct(\App|C\StructType\IFTIssuanceInfo $iFTIssuanceInfo = null, \App|C\StructType\ORGIssuanceInfo $oRGIssuanceInfo = null, \App|C\StructType\DATIssuanceInfo $dATIssuanceInfo = null, \App|C\StructType\PartnerIssuanceInfo $partnerIssuanceInfo = null, \App|C\ArrayType\ArrayOfETCouponExchangedInfo $eTCouponExchangedInfo = null)
    {
        $this
            ->setIFTIssuanceInfo($iFTIssuanceInfo)
            ->setORGIssuanceInfo($oRGIssuanceInfo)
            ->setDATIssuanceInfo($dATIssuanceInfo)
            ->setPartnerIssuanceInfo($partnerIssuanceInfo)
            ->setETCouponExchangedInfo($eTCouponExchangedInfo);
    }
    /**
     * Get IFTIssuanceInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\IFTIssuanceInfo|null
     */
    public function getIFTIssuanceInfo()
    {
        return isset($this->IFTIssuanceInfo) ? $this->IFTIssuanceInfo : null;
    }
    /**
     * Set IFTIssuanceInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\IFTIssuanceInfo $iFTIssuanceInfo
     * @return \App|C\StructType\ETTicketDetails
     */
    public function setIFTIssuanceInfo(\App|C\StructType\IFTIssuanceInfo $iFTIssuanceInfo = null)
    {
        if (is_null($iFTIssuanceInfo) || (is_array($iFTIssuanceInfo) && empty($iFTIssuanceInfo))) {
            unset($this->IFTIssuanceInfo);
        } else {
            $this->IFTIssuanceInfo = $iFTIssuanceInfo;
        }
        return $this;
    }
    /**
     * Get ORGIssuanceInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\ORGIssuanceInfo|null
     */
    public function getORGIssuanceInfo()
    {
        return isset($this->ORGIssuanceInfo) ? $this->ORGIssuanceInfo : null;
    }
    /**
     * Set ORGIssuanceInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\ORGIssuanceInfo $oRGIssuanceInfo
     * @return \App|C\StructType\ETTicketDetails
     */
    public function setORGIssuanceInfo(\App|C\StructType\ORGIssuanceInfo $oRGIssuanceInfo = null)
    {
        if (is_null($oRGIssuanceInfo) || (is_array($oRGIssuanceInfo) && empty($oRGIssuanceInfo))) {
            unset($this->ORGIssuanceInfo);
        } else {
            $this->ORGIssuanceInfo = $oRGIssuanceInfo;
        }
        return $this;
    }
    /**
     * Get DATIssuanceInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\DATIssuanceInfo|null
     */
    public function getDATIssuanceInfo()
    {
        return isset($this->DATIssuanceInfo) ? $this->DATIssuanceInfo : null;
    }
    /**
     * Set DATIssuanceInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\DATIssuanceInfo $dATIssuanceInfo
     * @return \App|C\StructType\ETTicketDetails
     */
    public function setDATIssuanceInfo(\App|C\StructType\DATIssuanceInfo $dATIssuanceInfo = null)
    {
        if (is_null($dATIssuanceInfo) || (is_array($dATIssuanceInfo) && empty($dATIssuanceInfo))) {
            unset($this->DATIssuanceInfo);
        } else {
            $this->DATIssuanceInfo = $dATIssuanceInfo;
        }
        return $this;
    }
    /**
     * Get PartnerIssuanceInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\PartnerIssuanceInfo|null
     */
    public function getPartnerIssuanceInfo()
    {
        return isset($this->PartnerIssuanceInfo) ? $this->PartnerIssuanceInfo : null;
    }
    /**
     * Set PartnerIssuanceInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\PartnerIssuanceInfo $partnerIssuanceInfo
     * @return \App|C\StructType\ETTicketDetails
     */
    public function setPartnerIssuanceInfo(\App|C\StructType\PartnerIssuanceInfo $partnerIssuanceInfo = null)
    {
        if (is_null($partnerIssuanceInfo) || (is_array($partnerIssuanceInfo) && empty($partnerIssuanceInfo))) {
            unset($this->PartnerIssuanceInfo);
        } else {
            $this->PartnerIssuanceInfo = $partnerIssuanceInfo;
        }
        return $this;
    }
    /**
     * Get ETCouponExchangedInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfETCouponExchangedInfo|null
     */
    public function getETCouponExchangedInfo()
    {
        return isset($this->ETCouponExchangedInfo) ? $this->ETCouponExchangedInfo : null;
    }
    /**
     * Set ETCouponExchangedInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfETCouponExchangedInfo $eTCouponExchangedInfo
     * @return \App|C\StructType\ETTicketDetails
     */
    public function setETCouponExchangedInfo(\App|C\ArrayType\ArrayOfETCouponExchangedInfo $eTCouponExchangedInfo = null)
    {
        if (is_null($eTCouponExchangedInfo) || (is_array($eTCouponExchangedInfo) && empty($eTCouponExchangedInfo))) {
            unset($this->ETCouponExchangedInfo);
        } else {
            $this->ETCouponExchangedInfo = $eTCouponExchangedInfo;
        }
        return $this;
    }
}
