<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FormOfPaymentRedirectResult StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:FormOfPaymentRedirectResult
 * @subpackage Structs
 */
class FormOfPaymentRedirectResult extends ApiObject
{
    /**
     * The HtmlForm
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $HtmlForm;
    /**
     * The UrlGet
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UrlGet;
    /**
     * The RedirectProperties
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfValueCodeProperty
     */
    public $RedirectProperties;
    /**
     * Constructor method for FormOfPaymentRedirectResult
     * @uses FormOfPaymentRedirectResult::setHtmlForm()
     * @uses FormOfPaymentRedirectResult::setUrlGet()
     * @uses FormOfPaymentRedirectResult::setRedirectProperties()
     * @param string $htmlForm
     * @param string $urlGet
     * @param \App|C\ArrayType\ArrayOfValueCodeProperty $redirectProperties
     */
    public function __construct($htmlForm = null, $urlGet = null, \App|C\ArrayType\ArrayOfValueCodeProperty $redirectProperties = null)
    {
        $this
            ->setHtmlForm($htmlForm)
            ->setUrlGet($urlGet)
            ->setRedirectProperties($redirectProperties);
    }
    /**
     * Get HtmlForm value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getHtmlForm()
    {
        return isset($this->HtmlForm) ? $this->HtmlForm : null;
    }
    /**
     * Set HtmlForm value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $htmlForm
     * @return \App|C\StructType\FormOfPaymentRedirectResult
     */
    public function setHtmlForm($htmlForm = null)
    {
        // validation for constraint: string
        if (!is_null($htmlForm) && !is_string($htmlForm)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($htmlForm, true), gettype($htmlForm)), __LINE__);
        }
        if (is_null($htmlForm) || (is_array($htmlForm) && empty($htmlForm))) {
            unset($this->HtmlForm);
        } else {
            $this->HtmlForm = $htmlForm;
        }
        return $this;
    }
    /**
     * Get UrlGet value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUrlGet()
    {
        return isset($this->UrlGet) ? $this->UrlGet : null;
    }
    /**
     * Set UrlGet value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $urlGet
     * @return \App|C\StructType\FormOfPaymentRedirectResult
     */
    public function setUrlGet($urlGet = null)
    {
        // validation for constraint: string
        if (!is_null($urlGet) && !is_string($urlGet)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($urlGet, true), gettype($urlGet)), __LINE__);
        }
        if (is_null($urlGet) || (is_array($urlGet) && empty($urlGet))) {
            unset($this->UrlGet);
        } else {
            $this->UrlGet = $urlGet;
        }
        return $this;
    }
    /**
     * Get RedirectProperties value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfValueCodeProperty|null
     */
    public function getRedirectProperties()
    {
        return isset($this->RedirectProperties) ? $this->RedirectProperties : null;
    }
    /**
     * Set RedirectProperties value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfValueCodeProperty $redirectProperties
     * @return \App|C\StructType\FormOfPaymentRedirectResult
     */
    public function setRedirectProperties(\App|C\ArrayType\ArrayOfValueCodeProperty $redirectProperties = null)
    {
        if (is_null($redirectProperties) || (is_array($redirectProperties) && empty($redirectProperties))) {
            unset($this->RedirectProperties);
        } else {
            $this->RedirectProperties = $redirectProperties;
        }
        return $this;
    }
}
